<template>
  <div class="page-container h-screen">
    <PageTitle :title="`${translate('labels.edit')}: ${user.first_name} ${user.last_name}`" />

    <div class="flex flex-col px-8">
      <v-form ref="form">
        <v-card>
          <v-text-field
            v-model="data.first_name"
            :label="translate('labels.first_name')"
            :rules="validator.setRules('required|min:2|max:50').validate()"
          ></v-text-field>

          <v-text-field
            v-model="data.last_name"
            :label="translate('labels.last_name')"
            :rules="validator.setRules('required|min:2|max:50').validate()"
          ></v-text-field>
          <v-select
            v-model="data.language_iso_code"
            :items="languages"
            item-title="label"
            item-value="language_iso_code"
            :rules="validator.setRules('required').validate()"
            :label="translate('language_selections.label')"
            required
          ></v-select>
        </v-card>
      </v-form>

      <div class="flex flex-col items-end py-4">
        <v-btn type="submit" color="primary" @click="updateModal" :prepend-icon="'mdi-content-save-outline'">
          {{ translate('labels.save') }}
        </v-btn>
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { ref, onMounted, defineProps } from 'vue'
import { useI18n } from 'vue-i18n'
import { useRouter } from 'vue-router'
import type { User } from '@/types/stores/userStoreTypes'
import { storeFactory } from '@/main'
import { Validator } from '@/helpers/Validator'
import { UserFormEvents } from '@/events/UserFormEvents'
import { TypesEnum } from '@/enums/userEnum'

// Components
import PageTitle from '@/components/page/PageTitle.vue'

const props = defineProps<{
  id: number;
  type?: string;
}>()

const router = useRouter()
const { t: translate } = useI18n()
const validator = new Validator()

const userStore = storeFactory.userStore
const roleStore = storeFactory.roleStore

const events: UserFormEvents = new UserFormEvents()

const form = ref(null) as any
const user = ref(userStore.getUserById(Number(props.id)) as User)
const roles = ref(roleStore.getRoles())
const languages = ref({ language_iso_code: 'pl_pl' }) // TODO: load
const authUser = ref(userStore.getUser as User)
let selectedRole = ref([]) as any

const data: any = ref({
  first_name: user.value?.first_name,
  last_name: user.value?.last_name,
  role_id: selectedRole.value,
  // language_iso_code: languages.value.filter(
  //     (language: object) => language.language_iso_code === user.value?.language_iso_code
  // )[0].language_iso_code,
  type: user.value?.type
})

onMounted(async () => {
  if (roleStore.getRoles()?.length === 0) {
    roles.value = (await roleStore.searchRoles(userStore.getUser?.id, {})).items
  }

  events.mount(data, props)
  events.register()
})

const updateModal = (): void => {
  storeFactory.modalStore.show({
    title: translate('users.update.modal.title'),
    icon: 'mdi-account-circle',
    body: translate('users.update.modal.message'),
    primary: {
      action: () => update(),
      type: 'success',
      label: translate('global.yes')
    },
    cancel: {
      action: () => {
      }
    }
  })
}

const update = async () => {
  if (!(await form.value.validate())?.valid) {
    return
  }
  data.value.role_id = data.value.type === TypesEnum.TYPE_ADMIN ? [data.value.role_id] : selectedRole.value;

  (await userStore.update(authUser.value.id, data.value)) &&
  (await userStore.update(user.value.id, data.value)) &&
  router.push({
    name: 'users.index'
  })
}
</script>
